/***
 * Created by Bryan Tai and Carolyn Shen Mar 21, 2016
 * Created for Project 4 of CPSC 314
*/
"use strict";
var game;
(function () {

  // init our global game object
  game = {};
  game.model = model;
  game.view = view;
  game.view.setup();
  game.dialogue = dialogueGenerator;
  game.hudCon = hudControls;
  // FPS code inspired by http://stackoverflow.com/questions/16432804/recording-fps-in-webgl
  game.frameCount = 0;
  game.fps = 0;
  game.elapsedTime = 0;
  game.lastTime = new Date().getTime();
  game.timeRemaining = 600000;
  game.terminate = false;
  game.endScreen = false;
  
//TODO move to view, if there's time
  game.animateDoor = false;
  game.doorToBeAnimated = null;
  game.doorFramesLeft = 0;

  game.gunEquipped = false; //TODO move to environment
  game.animateBullet = false;
  game.bulletFramesLeft = 0;
  
  var pickableObjects = view.pickable;
  
  
  // LISTEN FOR KEYBOARD INPUT
  var keyboard = new THREEx.KeyboardState();
  
  function updateWalkAnimation() {
    // if player is walking using wasd, will have nonzero dx or dz
    // decrease y, then increase y    
    // dir is a string; can be either "dx" or "dz"
    
    var dir = get_dir();
    if (dir) { // if we are moving
      if (player[dir] > 0 || player[dir] < 0) {
        // only walk if we pressed a key
        if (player.walk_counter < C.HALF_POINT) player.dy = -C.WALK_HEIGHT; // n
        else player.dy = C.WALK_HEIGHT;

        player.walk_counter++;
        if (player.walk_counter == C.WALK_FRAMES) { // 2*n + 1
          player.walk_counter = 0;
          player[dir] = 0;
          player.dy = 0;
        }
      }
    }
  }
  
  function animateDoor() {
    if (game.animateDoor) {
      var totalFrames = 12;
      var slice = (Math.PI/2)/totalFrames;
      var doorPanel = game.doorToBeAnimated;
      var doorParam = doorPanel.geometry.parameters;
	  
      if(!doorPanel.doorIsOpen){
		  doorPanel.translateX((doorParam.width/2)/totalFrames);
          doorPanel.rotateOnAxis(V.Y_AXIS, slice);
          doorPanel.translateZ((doorParam.width/2)/totalFrames);
      }else{
          doorPanel.translateZ((-doorParam.width/2)/totalFrames);
		  doorPanel.rotateOnAxis(V.Y_AXIS, -slice);
          doorPanel.translateX((-doorParam.width/2)/totalFrames);
      }
      game.doorFramesLeft--;
      if (game.doorFramesLeft == 0) {
        game.animateDoor = false;
        doorPanel.doorIsOpen = !doorPanel.doorIsOpen;
      }
    }
    
  }

function animateBullet(){
  if (game.animateBullet) {
	var distance = 50;

	view.moveBullet(distance);

	game.bulletFramesLeft--;
	if(game.bulletFramesLeft == 0){
		game.animateBullet = false;
		view.moveBullet(-distance*12);
	}

  }
  }
  
  function sync_directions() {
    // Prioritize dz direction
    player.dx = (player.dz) ? 0 : player.dx;
    player.dz = (player.dx) ? 0 : player.dz;
  }
  
  function get_dir() {
    var dir;
    if (player.dx) dir = "dx";
    else if (player.dz) dir = "dz";
    return dir;
  }
  
  function onKeyDown(event)
  {
      if(keyboard.eventMatches(event,"ctrl")){
        player.crouching = !player.crouching;
        player.crouch_dy = (player.crouching) ? -C.CROUCH_DX : C.CROUCH_DX;
      }
      //TODO make movement smoother
      if(keyboard.eventMatches(event,"w")){
        player.dz = C.W_DX;
      }
      if(keyboard.eventMatches(event,"a")){
        player.dx = C.A_DX;
      }
      if(keyboard.eventMatches(event,"s")){
        player.dz = C.S_DX;
      }
      if(keyboard.eventMatches(event,"d")){
        player.dx = C.D_DX;
      }
      //DEBUGGING TOOLS
      if(keyboard.eventMatches(event,"1")){
          view.fpCamera.faceCameraAt("door");
      }
      if(keyboard.eventMatches(event,"space")){
          lockCamera = !lockCamera;
      }
      if(keyboard.eventMatches(event,"y")){
          view.switchLights();
		  model.environ.triggerEvent("lightSwitch");
      }
      if(keyboard.eventMatches(event,"v")){
          model.environ.triggerEvent("adminKey");
      }
  }
  keyboard.domElement.addEventListener('keydown', onKeyDown );

  //TODO experiment with WASD acceleration
  //function onKeyUp(event)
  //{
  //	if(keyboard.eventMatches(event,"w")||keyboard.eventMatches(event,"a")||(keyboard.eventMatches(event,"s"))||(keyboard.eventMatches(event,"d")){
  //		
  //	}
  //}

//FOR MOUSE CAMERA
var lockCamera = false;

function isDoorPanel(pickedObj){
	return ("doorIsOpen" in pickedObj);
}

function handlePickedObject(pickedObj){
	var pickedName = pickedObj.name;

	var dialogueIndex = 0;
	
	var lightsOn = (model.environ.getEventState("lightSwitch") % 2 == 1);

	if(!lightsOn && (pickedName.localeCompare("lightSwitch") != 0)){
		pickedName = "dark";
	}else{
		switch(pickedName){
			//TODO find way to condense the switch/case in model or all here?
			//TODO put hudControls somewhere else?
			case "lightSwitch":
				view.switchLights();
				model.environ.triggerEvent(pickedName);
				dialogueIndex = model.environ.getEventState(pickedName) % 2;
			break;
			case "whiteboard":
				model.environ.triggerEvent(pickedName);
				hudControls.activateClue(0);
				dialogueIndex = (model.environ.getEventState(pickedName) > 1) ? 1:0;
			break;
			case "monitor0":
			case "monitor1":
				pickedName = "monitor"; //TODO hacky as shit
				var foundPassword = model.environ.getEventState("whiteboard") > 0;
				var loggedOn = model.environ.getEventState("monitor") == 1;
				var brokeComputer = model.environ.getEventState("monitor") > 1;
				if(!brokeComputer && foundPassword){
					model.environ.triggerEvent(pickedName);
					view.switchComputerScreen("loggedOn");
					dialogueIndex = 1;
				}
				if(loggedOn){
					model.environ.triggerEvent(pickedName);
					view.switchComputerScreen("bsod");
					hudControls.activateClue(1);
					dialogueIndex = 2;
				}if(brokeComputer){
					dialogueIndex = 3;
				}
			break;
		
			case "gun":
				model.environ.triggerEvent(pickedName);
				hudControls.activateClue(2);
				view.hideObjectByName("gunMesh");
				var foundBullets = model.environ.getEventState("bulletBox") > 0;
				if(foundBullets){
					view.equipGun();
					dialogueIndex = 1;
				}
			break;
			case "bulletBox":
				model.environ.triggerEvent(pickedName);
				hudControls.activateClue(3);
				view.hideObjectByName(pickedName);
				var foundGun = model.environ.getEventState("gun") > 0;
				if(foundGun){
					view.equipGun();
					dialogueIndex = 1;
				}
			break;
			case "highBox": //TODO consolidate highBox and adminKey into one single event.
				var usedComputer = model.environ.getEventState("monitor") > 1;
				var foundGun = model.environ.getEventState("gun") >0;
				var foundBullets = model.environ.getEventState("bulletBox") > 0;
				var droppedBox = model.environ.getEventState("highBox") > 0;
			
				if(!usedComputer){
					break;
				}
				if(!droppedBox && foundGun && foundBullets){
					model.environ.triggerEvent(pickedName);
						view.dropHighBox();
					dialogueIndex = 1;
				}if(droppedBox){
					model.environ.triggerEvent("adminKey");
					view.hideObjectByName(pickedName);
					hudControls.activateClue(4);
					dialogueIndex = 2;
				}
			break;
			case "locker":
				var gotKey = model.environ.getEventState("adminKey") > 0;
				if(gotKey){
					view.toggleDoor(pickedName);
					dialogueIndex = 1;
				}
			break;
			case "keycard":
				model.environ.triggerEvent(pickedName);
				hudControls.activateClue(5);
				view.hideObjectByName(pickedName);
			break;
			case "frontDoor":
				model.environ.triggerEvent(pickedName);
				var gotCard = model.environ.getEventState("keycard") > 0;
				if(gotCard){
					dialogueIndex = 2;
					winTheGame();
				}else{
					dialogueIndex = model.environ.getEventState(pickedName) % 2;
				}
		
			break;
		}
		if(isDoorPanel(pickedObj) && (pickedName.localeCompare("locker") != 0)){
			view.toggleDoor(pickedName);
		}
	}

	dialogueGenerator.changeDialogueForObj(pickedName,dialogueIndex);
console.log("PickedName ", pickedName);
}

function winTheGame(){
	//TODO 
	console.log("A WINNER IS YOU");
}

  //LISTEN FOR MOUSEDOWN
  //TODO might need to move this to a MODULE
  function onMouseDown(event){
	var picked = view.getObjectPicked();
	if(picked != null){
		handlePickedObject(picked);
	}
	if(game.gunEquipped && !game.animateBullet){
          game.animateBullet = true;
	  game.bulletFramesLeft = 12;
	}

  }
  document.addEventListener("mousedown", onMouseDown, false);
  
  function update() {
    
      var now = new Date().getTime();
      game.frameCount++;
      game.elapsedTime += (now-game.lastTime);
      
      game.lastTime = now;
    
      if (game.elapsedTime >= 1000) {
        // Timer countdown
        game.timeRemaining -= game.elapsedTime;
        var minutes = Math.floor(game.timeRemaining/60000);
        var seconds = Math.round((game.timeRemaining%60000)/1000);
        if (!game.terminated) {
          if (seconds < 0 || minutes < 0) {
            lockCamera = true;
            document.getElementById("end").innerHTML = "YOU DIED";
            game.terminate = true;
          } else {
            document.getElementById("time").innerHTML = minutes + " MIN, " + seconds + " SEC TIL STARVATION";
          }
        }


        
        // FPS counter
        game.fps = game.frameCount;
        game.frameCount = 0;
        game.elapsedTime -= 1000;
        document.getElementById("fps").innerHTML = "FPS: " + game.fps;
      }
    
      // Update the model
      sync_directions(); // Lock the ability to go in multiple directions at once
      updateWalkAnimation(); // we only walk in one direction if any
      //var pickedObject= view.getObjectPicked();
      //player.updateInventory(pickedObject);
      animateDoor();
	animateBullet();
      // Update the view
	if(!lockCamera){
      view.fpCamera.update(player.dx, player.crouch_dy || player.dy, player.dz, player.crouching);
	}
      view.objectPicker.updatePicked(pickableObjects);
	  
	  dialogueGenerator.updateDialogue();

      view.fpCamera.camera.updateProjectionMatrix();
      view.renderer.render(view.scene,view.fpCamera.camera);

      requestAnimationFrame(update);
    
      // reset variables at the end of update
      player.crouch_dy = 0;

  }

update();
}());
