
var initObjects = {
	normalMaterial: new THREE.MeshNormalMaterial(),
	basicGreyMaterial: new THREE.MeshBasicMaterial({color:0xd6d6c2}),
	basicGreenMaterial: new THREE.MeshBasicMaterial({color:0x55AE3A}),
	roomWidth: 100,
	roomLength: 100,
	roomHeight: 50,
	
	makeCube: function(){
	    var unitCube = new THREE.BoxGeometry(1,1,1);
	    return unitCube;
	},
	makeFloor: function(){
		var floorGeometry = new THREE.BoxGeometry(this.roomWidth,0.5,this.roomLength);
		var floorMesh = new THREE.Mesh(floorGeometry, this.basicGreenMaterial);//TODO Make this carpet
		scene.add(floorMesh);
	},
	makeWallMesh:function(){
		var wallGeometry = new THREE.BoxGeometry(this.roomLength,this.roomHeight,0.5);
		var wallMesh = new THREE.Mesh(wallGeometry, this.basicGreyMaterial);
		return wallMesh;
	},
	makeWalls: function(){
		for(var i = 0; i < 4; i++){
			var wall = this.makeWallMesh();
			wall.translateY(this.roomHeight/2);
			wall.rotateOnAxis(new THREE.Vector3(0,1,0), i * Math.PI / 2);
			wall.translateZ(this.roomWidth/2);
			scene.add(wall);
		}
	},
	
	//TODO add object models here
	createEverything: function(scene){
		
		
		var cubeGeom = this.makeCube();
		cubeGeom.scale = 5;
		
		//If a mesh needs to be accessed in the main file
		//give it a name
		var testCube = new THREE.Mesh(cubeGeom, this.normalMaterial);
		testCube.name = "testCube";
		var greenCube = new THREE.Mesh(cubeGeom, this.basicGreenMaterial);
		greenCube.name = "greenCube";
		
		this.makeFloor();
		this.makeWalls();
		
		testCube.translateY(20);
		testCube.translateX(-this.roomWidth/2);
		greenCube.translateY(22);
		greenCube.translateZ(-this.roomLength/2);
		
		scene.add(testCube);
		scene.add(greenCube);
	}
}
