/***
 * Created by Bryan Tai and Carolyn Shen Mar 25, 2016
 * Created for Project 4 of CPSC 314
*/

var dialogueGenerator = (function(){
  "use strict";
  /*** Module for Dialogue Generator ***/
  var dialogueDiv = document.getElementById('dialogue');
	const DEFAULT_FRAME_COUNT = 240;
	var frame_counter = DEFAULT_FRAME_COUNT;
	var pickedObj = null;
	var defaultDialogue = "I'm locked in. How do I get out of here?";
	
	//TODO make these an object of arrays for multiple dialogue options per object
	var _objToDialogue = {
	dark: ["I can't see in the dark... I should turn on the lights first."],
	frontDoor : ["This door is locked on the inside. Who would do such a thing?", "I need a keycard to open this...","It worked! The door's open! I'm free!"],
    monitor : ["A computer in the computer science club room, no surprises there. I don't know the password so I can't use it.","Looks like the password works! Someone else is online! I can ask them for help!","...And the computer crashed. Great. At least the person told me that there's a key in a box on the high shelf.", "I should just...leave that alone for now... Maybe that key in the high shelf will help." ],
	lightSwitch: ["Lights off!","Lights on!"],
	cabinet : ["Anything up here? I guess not."],
	whiteboard : ["This looks like... a password? Who'd be dumb enough to write one here?","The password for something is \"tittysprinkles\"..."],
	freezer: ["No more burritos... I'm gonna starve..."],
	bottom: ["Empty. Just like my stomach."],
	metalFridge: ["Why even have 3 fridges if none of them have food?"],
	execFridge: ["I shouldn't be looking in the executive fridge but there's nothing in here anyways..."],
	locker: ["The Admin's Locker. I can't open this without a key of some sort.", "Alright! The key worked! Let's see what's in this locker..."],
	window: ["I can't reach these windows. If only the game developers programmed a jump button..."],
	gun: ["A nerf gun! But there aren't any bullets...","A nerf gun! Time to put these bullets to good use"],
	tv: ["This is no time for video games."],
	bulletBox: ["Oh boy! A whole box of nerf bullets!","Nerf bullets! Time to put this gun to good use"],
	highBox: ["Hmm, I'm too short to reach that box... Probably useless anyways.","I can shoot down this high box with my darts! Although... I could have just thrown something else at it... oh well.","Aha, there's a key in this box. Looks like it's for the Admin locker."],
	keycard: ["A keycard! I really hope this opens the front door."]
  };
	
	function setDialogue(newDialogue){
		dialogueDiv.innerHTML = newDialogue;
		frame_counter = DEFAULT_FRAME_COUNT;
	}
	
	function changeDialogueForObj(objName,dialogueIndex){
console.log("NYAA",objName);
		if(objName in _objToDialogue){
			var dialogueForObj = _objToDialogue[objName];
			setDialogue(dialogueForObj[dialogueIndex]);
console.log("OOOO",objName);
		}
	}
	
	function updateDialogue() {
	if (frame_counter >= 0) { // if we're still displaying message from prev object
      frame_counter--;
    }else{
		setDialogue(defaultDialogue);
	}
  }

  function getDialogue(obj) {
    return _objToDialogue[obj];
  }
  
  return {
	changeDialogueForObj:changeDialogueForObj,
    updateDialogue : updateDialogue,
    frame_counter : frame_counter,
    pickedObj : pickedObj,
	getDialogue:getDialogue
  };
})();
