/***
 * Created by Bryan Tai and Carolyn Shen Mar 25, 2016
 * Created for Project 4 of CPSC 314
*/

// Global variables among View modules
V = (function () {
  "use strict";
  const X_AXIS = new THREE.Vector3( 1, 0, 0 );
  const Y_AXIS = new THREE.Vector3( 0, 1, 0 );
  const Z_AXIS = new THREE.Vector3( 0, 0, 1 );
  
  const CEILING_LIGHT_INTENSITY = 0.1;
  const CENTER_LIGHT_INTENSITY = 0.8;
  const WINDOW_LIGHT_INTENSITY = 0.1;
  
  //See Bryan's Notebook for room dimensions
  const ROOM_WIDTH = 630;  //X axis
  const ROOM_HEIGHT = 300;  //Y axis
  const ROOM_LENGTH = 630; //Z axis //NOTE: it's actually 610cm but it'll be easier if it's square
  const FRIDGE_BOUNDARY = 75; //limit on left side of room
  const BLOCKER_WIDTH = 150; //x limit on top right side of room
  const BLOCKER_LENGTH = 170;//z
  const TABLE_ROW_WIDTH = 80; //x limit on bottom side of room 
  const TABLE_ROW_LENGTH = 450;//z (3 times the length of a table)
  
  const PLAYER_HEIGHT = 130;
  const PLAYER_CROUCH_HEIGHT = 50;
  const PLAYER_REACH = 200; //How far raycaster picking can affect
  
  var camera = new THREE.PerspectiveCamera(30,1,1,1000); // FOV, aspect ratio, near, far
  var scene = new THREE.Scene();

  return {
    X_AXIS: X_AXIS,
    Y_AXIS: Y_AXIS,
    Z_AXIS: Z_AXIS,
    ROOM_WIDTH: ROOM_WIDTH,
    ROOM_LENGTH: ROOM_LENGTH,
    ROOM_HEIGHT: ROOM_HEIGHT,
	
	FRIDGE_BOUNDARY: FRIDGE_BOUNDARY,
	BLOCKER_WIDTH :BLOCKER_WIDTH, 
	BLOCKER_LENGTH:BLOCKER_LENGTH,
	TABLE_ROW_WIDTH: TABLE_ROW_WIDTH,
	TABLE_ROW_LENGTH: TABLE_ROW_LENGTH,
	
	PLAYER_HEIGHT: PLAYER_HEIGHT,
	PLAYER_REACH: PLAYER_REACH,
    PLAYER_CROUCH_HEIGHT: PLAYER_CROUCH_HEIGHT,
	CEILING_LIGHT_INTENSITY: CEILING_LIGHT_INTENSITY,
    WINDOW_LIGHT_INTENSITY: WINDOW_LIGHT_INTENSITY,
    CENTER_LIGHT_INTENSITY: CENTER_LIGHT_INTENSITY,
    
	camera: camera,
	scene: scene
  };
})();